"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * A reimplementation of React Native Screens for React NativeScript.
 * @see https://github.com/software-mansion/react-native-screens/blob/73959abc975b5718e683d39f1452ec0bb4d5f475/native-stack/views/HeaderConfig.tsx
 */
var React = require("react");
var screens_1 = require("../../react-nativescript-screens/screens");
function HeaderConfig(props) {
    // const { colors } = useTheme();
    var route = props.route, title = props.title, headerRight = props.headerRight, headerLeft = props.headerLeft, headerCenter = props.headerCenter, headerTitle = props.headerTitle, headerBackTitle = props.headerBackTitle, _a = props.headerBackTitleVisible, headerBackTitleVisible = _a === void 0 ? true : _a, backButtonImage = props.backButtonImage, 
    // headerHideBackButton,
    headerHideShadow = props.headerHideShadow, 
    // headerLargeTitleHideShadow,
    headerTintColor = props.headerTintColor, 
    // headerLargeTitle,
    headerTranslucent = props.headerTranslucent, _b = props.headerStyle, headerStyle = _b === void 0 ? {} : _b, 
    // headerLargeStyle = {},
    // headerTitleStyle = {},
    // headerLargeTitleStyle = {},
    // headerBackTitleStyle = {},
    headerShown = props.headerShown;
    return (React.createElement(screens_1.ScreenStackHeaderConfig
    // hidden={headerShown === false}
    // backButtonInCustomView={backButtonInCustomView}
    , { 
        // hidden={headerShown === false}
        // backButtonInCustomView={backButtonInCustomView}
        flat: !headerTranslucent && headerHideShadow, 
        // hideShadow={headerHideShadow}
        // largeTitleHideShadow={headerLargeTitleHideShadow}
        // hideBackButton={headerHideBackButton}
        title: 
        // headerCenter (a custom titleView) takes priority over title.
        headerCenter !== undefined ?
            undefined :
            headerTitle !== undefined
                ? headerTitle
                : title !== undefined
                    ? title
                    : route.name, 
        // titleFontFamily={headerTitleStyle.fontFamily}
        // titleFontSize={headerTitleStyle.fontSize}
        // titleColor={
        //   headerTitleStyle.color !== undefined
        //     ? headerTitleStyle.color
        //     : headerTintColor !== undefined
        //     ? headerTintColor
        //     : colors.text
        // }
        // backTitle={headerBackTitleVisible ? headerBackTitle : ' '}
        // backTitleFontFamily={headerBackTitleStyle.fontFamily}
        // backTitleFontSize={headerBackTitleStyle.fontSize}
        color: headerTintColor !== undefined ?
            headerTintColor :
            // colors.primary
            undefined, 
        // largeTitle={headerLargeTitle}
        // largeTitleFontFamily={headerLargeTitleStyle.fontFamily}
        // largeTitleFontSize={headerLargeTitleStyle.fontSize}
        // largeTitleColor={headerLargeTitleStyle.color}
        backgroundColor: headerStyle.backgroundColor !== undefined
            ? headerStyle.backgroundColor
            // : colors.card
            : undefined },
        headerRight !== undefined ? (React.createElement(screens_1.ScreenStackHeaderRightView, null, headerRight({
            tintColor: headerTintColor !== null && headerTintColor !== void 0 ? headerTintColor : 
            // colors.primary
            undefined
        }))) : null,
        backButtonImage !== undefined ? (
        // TODO: pass isEnabled={!disabled}
        React.createElement(screens_1.ScreenStackHeaderBackButtonImage, { key: "backImage", icon: backButtonImage, text: headerBackTitle })) : null,
        headerLeft !== undefined ? (React.createElement(screens_1.ScreenStackHeaderLeftView, null, headerLeft({
            tintColor: headerTintColor !== null && headerTintColor !== void 0 ? headerTintColor : 
            // colors.primary
            undefined
        }))) : null,
        headerCenter !== undefined ? (React.createElement(screens_1.ScreenStackHeaderCenterView, null, headerCenter({
            tintColor: headerTintColor !== null && headerTintColor !== void 0 ? headerTintColor : 
            // colors.primary
            undefined
        }))) : null));
}
exports.default = HeaderConfig;
//# sourceMappingURL=HeaderConfig.js.map