"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by following the React Navigation docs.
 * @see https://reactnavigation.org/docs/custom-navigators/
 */
var React = require("react");
var core_1 = require("@react-navigation/core");
function TabNavigator(_a) {
    var initialRouteName = _a.initialRouteName, children = _a.children, screenOptions = _a.screenOptions, tabBarStyle = _a.tabBarStyle, contentStyle = _a.contentStyle;
    var _b = core_1.useNavigationBuilder(core_1.TabRouter, {
        children: children,
        screenOptions: screenOptions,
        initialRouteName: initialRouteName,
    }), state = _b.state, navigation = _b.navigation, descriptors = _b.descriptors;
    // console.log(`[TabNavigator] render`);
    return (React.createElement("tabs", { style: { width: "100%", height: "100%", }, selectedIndex: state.index, 
        // onSelectedIndexChange={(args) => {
        //   console.log(`[Tabs.onSelectedIndexChange] ${args.oldValue} -> ${args.value}`);
        // }}
        /**
         * Firing the navigation event upon onSelectedIndexChanged handles both the case of
         * tapping the target TabStripItem and swiping between TabContentItems.
         *
         * There is also onSelectedIndexChange (the Property change event) which fires afterward.
         * I think either work fine; would have to closely inspect the implementation to say more.
         */
        onSelectedIndexChanged: function (args) {
            // console.log(`[Tabs.onSelectedIndexChanged] ${args.oldIndex} -> ${args.newIndex}`);
            var route = state.routes[args.newIndex];
            var event = navigation.emit({
                type: 'tabPress',
                target: route.key,
                canPreventDefault: true,
            });
            // console.log(`[Tabs.onSelectedIndexChanged] emitted event`, event);
            // Can't figure out typings, but defaultPrevented is clearly a populated boolean.
            if (!event.defaultPrevented) {
                navigation.dispatch(__assign(__assign({}, core_1.TabActions.jumpTo(route.name)), { target: state.key }));
            }
        } },
        React.createElement("tabStrip", { nodeRole: "tabStrip" }, state.routes.map(function (route) { return (React.createElement("tabStripItem", { key: route.key, nodeRole: "items" },
            React.createElement("label", { nodeRole: "label", style: {} }, descriptors[route.key].options.title || route.name),
            React.createElement("image", { nodeRole: "image", style: {} }))); })),
        state.routes.map(function (route) { return (React.createElement("tabContentItem", { key: route.key, nodeRole: "items" }, descriptors[route.key].render())); })));
}
exports.default = core_1.createNavigatorFactory(TabNavigator);
//# sourceMappingURL=tabNavigatorFactory.js.map