"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function memoize(callback) {
    var previous;
    var result;
    return function () {
        var dependencies = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            dependencies[_i] = arguments[_i];
        }
        var hasChanged = false;
        if (previous) {
            if (previous.length !== dependencies.length) {
                hasChanged = true;
            }
            else {
                for (var i = 0; i < previous.length; i++) {
                    if (previous[i] !== dependencies[i]) {
                        hasChanged = true;
                        break;
                    }
                }
            }
        }
        else {
            hasChanged = true;
        }
        previous = dependencies;
        if (hasChanged || result === undefined) {
            result = callback.apply(void 0, __spread(dependencies));
        }
        return result;
    };
}
exports.default = memoize;
//# sourceMappingURL=memoize.js.map